SHEBANG
# Copyright @BABOLO (C)2013 http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: up.m4,v 1.2 2013/01/15 12:26:03 babolo Exp $

JNTROSTUP(vhost,,dnl
,dnl
# jailup vhost dir jailname jailaddr param=value ...
#     where jailname - hostname for jail (see jail(2) hostname)
#           jailaddr - IP addr for jail (see jail(2) ip_number)
#           dir relative to ${JAILUPDIR} and ${JAILRODIR}
dnl
)

jdir="${1}"
jailsname="${2}"
jailsaddr="${3}"
p1="${4}"
p2="${5}"
p3="${6}"
p4="${7}"
p5="${8}"
p6="${9}"
p7="${10}"
p8="${11}"
p9="${12}"
main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"
if  [ -n "${CONFSHIFT}" ]; then
    conf_dir="${conf_dir}/${CONFSHIFT}"
fi

${up_adc} "${conf_dir}/hosts.allow" <<- EOF
	sshd : ALL : deny
EOF

${pwd_mkdb} -d "${conf_dir}" -p "${conf_dir}/master.passwd"
[ ! -e "${conf_dir}/ssh/ssh_host_ecdsa_key" ] \
                                  && ${keygen} -t ecdsa -N "" -f "${conf_dir}/ssh/ssh_host_ecdsa_key"
[ ! -e "${conf_dir}/ssh/ssh_host_dsa_key"   ] \
                                  && ${keygen} -t dsa   -N "" -f "${conf_dir}/ssh/ssh_host_dsa_key"
[ ! -e "${conf_dir}/ssh/ssh_host_rsa_key"   ] \
                                  && ${keygen} -t rsa   -N "" -f "${conf_dir}/ssh/ssh_host_rsa_key"
[ ! -e "${conf_dir}/ssh/ssh_host_key"       ] \
                                  && ${keygen} -t rsa1  -N "" -f "${conf_dir}/ssh/ssh_host_key"

${up_adc} "${JAILUPRC}" <<- EOF
#${genclass}	${inclass}	${jdir}	${jailsname}	${jailsaddr}	0	${p1}	${p2}	${p3}	${p4}	${p5}	${p6}	${p7}	${p8}	${p9}
EOF
      #####################################
      ####                             ####
      #### Begin of fstab mod          ####
      ####                             ####
${up_adc} "${etcdir}/fstab" <<- EOF
	#devfs			${main_dir}/dev	devfs	rw		0 0
	#${conf_dir}		${main_dir}/etc	nullfs	ro,nosuid	0 0
EOF

${up_adc} "${STARTUPDIR}/devfs" <<- EOF
	${jdir}	full	vhost
EOF
      ####                             ####
      #### End of fstab mod            ####
      ####                             ####
      #####################################
